unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, graphutil;
  //_----------------------------
  //  graphutil

type
  TForm2 = class(TForm)
    Button1: TButton;
    Timer1: TTimer;
    Image1: TImage;
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;
  bmp,bmp_draw:Tbitmap;

implementation

{$R *.dfm}
procedure recolor(bmp:Tbitmap; hue:byte; var res:tbitmap);  //
var i,j:integer;
h,l,s:word;
begin
  for I := 0 to bmp.Width - 1 do
  for j := 0 to bmp.Height - 1 do
    begin
      colorrgbtohls(bmp.Canvas.Pixels[I,J],h,l,s);   // Hue,light,station  
      res.Canvas.Pixels[I,J]:=colorhlstorgb(hue,l,s); // 
    end;

end;

procedure TForm2.Button1Click(Sender: TObject);
begin
timer1.Enabled:=not timer1.Enabled;
if not timer1.Enabled then button1.Caption:='Start' else  button1.Caption:='Stop';

end;

procedure TForm2.FormCreate(Sender: TObject);
begin
bmp:=Tbitmap.Create;
bmp_draw:=Tbitmap.Create;
bmp.LoadFromFile('ufo.bmp');        // 
bmp_draw.LoadFromFile('ufo.bmp');   //   
randomize;
end;

procedure TForm2.FormDestroy(Sender: TObject);
begin
bmp.Free;
bmp_draw.Free;
end;

procedure TForm2.Timer1Timer(Sender: TObject);
var x,y:integer;
begin
image1.Canvas.FillRect(bounds(0,0,image1.Width,image1.Height));
//  
x:=random(image1.Width-bmp_draw.Width);
y:=random(image1.Height-bmp_draw.Height);
if y div 12 = 0  then   recolor(bmp,random(240),bmp_draw);
//

image1.Canvas.Draw(x,y,bmp_draw);
// 


end;

end.

